/// <reference types="react" />
import React from 'react';
import { AbstractTooltipProps } from '../tooltip';
import { ButtonType } from '../button/button';
export interface PopconfirmProps extends AbstractTooltipProps {
    title: React.ReactNode;
    onConfirm?: (e: React.MouseEvent<any>) => void;
    onCancel?: (e: React.MouseEvent<any>) => void;
    okText?: React.ReactNode;
    okType?: ButtonType;
    cancelText?: React.ReactNode;
}
export default class Popconfirm extends React.Component<PopconfirmProps, any> {
    static defaultProps: {
        prefixCls: string;
        transitionName: string;
        placement: string;
        trigger: string;
        okType: string;
    };
    private tooltip;
    constructor(props: PopconfirmProps);
    componentWillReceiveProps(nextProps: PopconfirmProps): void;
    getPopupDomNode(): any;
    onConfirm: (e: any) => void;
    onCancel: (e: any) => void;
    onVisibleChange: (visible: any) => void;
    setVisible(visible: any): void;
    saveTooltip: (node: any) => void;
    renderOverlay: (popconfirmLocale: any) => JSX.Element;
    render(): JSX.Element;
}
